package com.bayometric.javasample;

import java.awt.EventQueue;

import javax.swing.DefaultListModel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;

import java.awt.Font;

import javax.swing.JTextField;
import javax.swing.JButton;







import com.bayometric.www.AuthRequestInfo;
import com.bayometric.www.BFSAuthResponse;
import com.bayometric.www.BFSClientReturnErrorCode;
import com.bayometric.www.BFSInfoResponse;
import com.bayometric.www.BFSResponse;
import com.bayometric.www.BFSResponseBase;
import com.bayometric.www.UranusCoreProxy;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.rmi.RemoteException;

import javax.swing.JList;

public class MainWindow {

	private JFrame frame;
	private JTextField tbGuid;

	UranusCoreProxy client = new UranusCoreProxy();
    private String SessionKey = null;
    private String AppToken = "BayometricJavaSampleAppToken";
    private Boolean ShowGUI = true;
    private int Timeout = 30;
    private Thread searchThread;
	
    private DefaultListModel usersListModel;
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					MainWindow window = new MainWindow();
					window.frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public MainWindow() {
		usersListModel = new DefaultListModel();
		initialize();
		
		
	}

	private boolean ValidateIDToDelete()
    {
        return !((tbGuid.getText() == ""));
    }
	
	private void CreateSession()
	{
		AuthRequestInfo authRequestInfo = new AuthRequestInfo();
		authRequestInfo.setShowGUI(ShowGUI);
		authRequestInfo.setTimeout(Timeout);
		BFSAuthResponse result;
		try {
			result = client.createSession(authRequestInfo);
			if (result.getResponseCode() == BFSClientReturnErrorCode.SUCCESS)
            {
                SessionKey = result.getSessionKey();
                JOptionPane.showMessageDialog(null,"User authenticated. SessionKey = " + SessionKey, "Success", JOptionPane.INFORMATION_MESSAGE);
                
            }
            else
            {
            	JOptionPane.showMessageDialog(null,"Coult not authenticate. Reason: " + result.getReturnMessage(), "Error", JOptionPane.INFORMATION_MESSAGE);
                
            }
		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}

	private void EndSession()
	{
		BFSResponseBase result;
		try {
			result = client.endSession(SessionKey);
			if (result.getResponseCode() == BFSClientReturnErrorCode.SUCCESS)
	        {
	        	JOptionPane.showMessageDialog(null,"Session ended", "Success", JOptionPane.INFORMATION_MESSAGE);
	            SessionKey = null;
	        }
	        else
	        {
	        	JOptionPane.showMessageDialog(null,"Coult end session. Reason: " + result.getReturnMessage(), "Error", JOptionPane.INFORMATION_MESSAGE);
	        }
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        
	}
	
	private void RegisterPerson()
	{
		String personID = tbGuid.getText().equals("") ? null : tbGuid.getText();
		
		BFSResponse result;
		try {
			result = client.registerPerson(SessionKey,personID);
			if (result.getResponseCode() == BFSClientReturnErrorCode.SUCCESS)
	        {
	        	JOptionPane.showMessageDialog(null,"User registered", "Success", JOptionPane.INFORMATION_MESSAGE);
	            tbGuid.setText(result.getPersonFoundID());
	        }
	        else
	        {
	        	JOptionPane.showMessageDialog(null,"Coult register person. Reason: " + result.getReturnMessage(), "Error", JOptionPane.INFORMATION_MESSAGE);
	        }
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    }
	
	private void UnregisterPerson()
	{
		if (ValidateIDToDelete())
        {
            BFSResponse result;
			try {
				result = client.unregisterPerson(SessionKey, tbGuid.getText());
				if (result.getResponseCode() == BFSClientReturnErrorCode.SUCCESS)
	            {
	            	JOptionPane.showMessageDialog(null,"User removed", "Success", JOptionPane.INFORMATION_MESSAGE);
	            }
	            else
	            {
	            	JOptionPane.showMessageDialog(null,"Coult delete person. Reason: " + result.getReturnMessage(), "Error", JOptionPane.INFORMATION_MESSAGE);
	            }
			} catch (RemoteException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
            
        }
        else
        {
        	JOptionPane.showMessageDialog(null,"Biometric ID can't be empty.", "Error", JOptionPane.INFORMATION_MESSAGE);
        }
	}
	
	private void Search()
	{
		searchThread = new Thread(new Runnable() {
		     public void run() {
		          try {
		        	  BFSResponse result;
		        	  result = client.search();
		        	  
		        	  /*
		               * Calling search() is the same as calling searchEx the following way
		               * result = client.searchEx(null,  null , true, 30);
		               * */
		        	  
		        	  
		        	  
		  	        	JOptionPane.showMessageDialog(null,"Message: " + result.getReturnMessage() + "  PersonFoundID: " + result.getPersonFoundID(), "Information", JOptionPane.INFORMATION_MESSAGE);
		  	       
				} catch (RemoteException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
		     }
		});  
		searchThread.start();
	}
	
	private void CancelSearch()
	{
		BFSResponse result;
		try {
			result = client.cancelSearch(null);
			if (result.getResponseCode() == BFSClientReturnErrorCode.SUCCESS)
	        {
	        	JOptionPane.showMessageDialog(null,"Search canceled", "Success", JOptionPane.INFORMATION_MESSAGE);

	        }
	        else
	        {
	        	JOptionPane.showMessageDialog(null,"Could not cancel search. Reason: " + result.getReturnMessage(), "Error", JOptionPane.INFORMATION_MESSAGE);

	        }
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        
	}
	
	private void GetRegisteredPersons() 
	{
		
		
		BFSInfoResponse result;
		try {
			//Only getting 30 IDs. Check documentation for information on how to get more
			result = client.getRegisteredPersons(0, 30);
			if (result.getResponseCode() == BFSClientReturnErrorCode.SUCCESS || result.getResponseCode() == BFSClientReturnErrorCode.END_OF_LIST)
	        {
				
				usersListModel.clear();
	        	for(String id : result.getRegisteredPersons())
	        	{
	        		
	        		usersListModel.addElement(id);
	        	}
	            
	        }
	        else
	        {
	        	JOptionPane.showMessageDialog(null,"Coult list users. Reason: " + result.getReturnMessage(), "Error", JOptionPane.INFORMATION_MESSAGE);
	        }
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		
		frame = new JFrame();
		frame.setResizable(false);
		frame.setBounds(100, 100, 598, 350);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.getContentPane().setLayout(null);
		
		JLabel lblBiometricId = new JLabel("Biometric ID:");
		lblBiometricId.setFont(new Font("Tahoma", Font.PLAIN, 18));
		lblBiometricId.setBounds(10, 11, 113, 35);
		frame.getContentPane().add(lblBiometricId);
		
		tbGuid = new JTextField();
		tbGuid.setBounds(133, 17, 285, 29);
		frame.getContentPane().add(tbGuid);
		tbGuid.setColumns(10);
		
		JButton btCreateSession = new JButton("Create Session");
		btCreateSession.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				CreateSession();
	        }
		});
		
		btCreateSession.setBounds(446, 14, 136, 29);
		frame.getContentPane().add(btCreateSession);
		
		JButton btEndSession = new JButton("End Session");
		btEndSession.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				EndSession();
			}
		});
		btEndSession.setBounds(446, 47, 136, 29);
		frame.getContentPane().add(btEndSession);
		
		JButton btRegisterPerson = new JButton("Register Person");
		btRegisterPerson.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				RegisterPerson();
			}
		});
		btRegisterPerson.setBounds(446, 89, 136, 29);
		frame.getContentPane().add(btRegisterPerson);
		
		JButton btUnregisterPerson = new JButton("Unregister Person");
		btUnregisterPerson.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				UnregisterPerson();
			}
		});
		btUnregisterPerson.setBounds(446, 125, 136, 29);
		frame.getContentPane().add(btUnregisterPerson);
		
		JButton btSearch = new JButton("Search");
		btSearch.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				Search();
			}
		});
		btSearch.setBounds(446, 176, 136, 29);
		frame.getContentPane().add(btSearch);
		
		JButton btCancelSearch = new JButton("Cancel Search");
		btCancelSearch.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				CancelSearch();
			}
		});
		btCancelSearch.setBounds(446, 209, 136, 29);
		frame.getContentPane().add(btCancelSearch);
		
		JLabel lblRegisteredUsers = new JLabel("Registered Users:");
		lblRegisteredUsers.setBounds(10, 125, 162, 14);
		frame.getContentPane().add(lblRegisteredUsers);
		
		JList list = new JList(usersListModel);
		list.setBounds(10, 150, 285, 160);
		frame.getContentPane().add(list);
		
		JButton btListUsers = new JButton("List Users");
		btListUsers.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				GetRegisteredPersons();
			}
		});
		btListUsers.setBounds(446, 266, 136, 29);
		frame.getContentPane().add(btListUsers);
	}

	
}
